
#ifndef __UTILS_H__
#define __UTILS_H__

int MoveStr(char *dest, const char *src);

int Uint8ToStr (char *dest, uint8_t val);
int Int8ToStr(char *dest, int8_t val);

int Uint16ToStr(char *dest, uint16_t val);
int Int16ToStr (char *dest, int16_t val);

int Uint32ToStr(char *dest, uint32_t val);

int ppctoint(const char **ppc);
int pctoint(const char *pc);
float ppctofloat(const char **ppc);
float pctofloat(const char *pc);

#define DECIPOINT_EXP	0x10
//Achtung *ret min 16 char's
void floattoppc(char **ppc, float w, int decipoint);
int floattopc(char *pc, float w, int decipoint);

void chkf(float *pf, float min, float max, float def);

#endif /* __UTILS_H__ */
