.syntax unified
.cpu cortex-m33
.fpu softvfp
.thumb
.thumb_func

	oIRR_Y		= 0
	oIRR_X		= 4
	oIRR_kA		= 8
	oIRR_kB		= 12

.section	.text.irr16b_32_k3FFF
.global irr16b_32_k3FFF
.syntax unified
.thumb
.thumb_func

.align 4

//int32_t irr16b_32_k3FFF(TIIR32 *p, int32_t value)

irr16b_32_k3FFF:
	push	{r4}
	mov	r4, r0

	lsls	r1, #15

	ldr	r2, [r4, #oIRR_kA]
	ldr	r3, [r4, #oIRR_X]
	str	r1, [r4, #oIRR_X]
	adds	r3, r1
	smull	r0, r1, r2, r3

	ldr	r3, [r4, #oIRR_kB]
	ldr	r2, [r4, #oIRR_Y]
	smlal	r0, r1, r2, r3

	lsrs	r0, r0, #15
	orr	r0, r0, r1, lsl #17

	str	r0, [r4, #oIRR_Y]

	asrs	r0, r0, #15
	adc	r0, r0, #0

	pop	{r4}
	bx	lr

.section	.text.irr16b_32_k3FFF_init
.global irr16b_32_k3FFF_init
.syntax unified
.thumb
.thumb_func

.align 4

//void irr16b_32_k3FFF_init(TIIR32 *p, int32_t k)

irr16b_32_k3FFF_init:
	str	r1, [r0, #oIRR_kA]
	lsls	r1, #1
	rsb	r1, r1, #0x8000
	str	r1, [r0, #oIRR_kB]
	movs	r1, #0
	str	r1, [r0, #oIRR_Y]
	str	r1, [r0, #oIRR_X]
	bx	lr
